﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=9.85
@EndOfDesignText@
#Region Shared Files
#CustomBuildAction: folders ready, %WINDIR%\System32\Robocopy.exe,"..\..\Shared Files" "..\Files"
'Ctrl + click to sync files: ide://run?file=%WINDIR%\System32\Robocopy.exe&args=..\..\Shared+Files&args=..\Files&FilesSync=True
#End Region

'Ctrl + click to export as zip: ide://run?File=%B4X%\Zipper.jar&Args=Project.zip

Sub Class_Globals
	Private Root As B4XView
	Private xui As XUI
	
	Private CLV As CustomListView
	Private PressTimer, PressTimeDiff As Long
	Private TouchedPanel As B4XView
	Private PanelCLVindexFromoffset, TouchedPanelCLVIndex  As Int
End Sub

Public Sub Initialize
'	B4XPages.GetManager.LogEvents = True
End Sub

'This event will be called once, before the page becomes visible.
Private Sub B4XPage_Created (Root1 As B4XView)
	Root = Root1
	Root.LoadLayout("MainPage")
	
	For i = 1 To 10
		Private Panel As B4XView = xui.CreatePanel("Panel")
		Panel.SetLayoutAnimated(0, 0, 0, 80dip, 80dip)
		Panel.Color = Colors.Blue
		
		Private text As Label
		text.Initialize("")
		text.Text = "Panel " & i
		text.TextSize = 16
		text.TextColor = Colors.White
		
		Panel.AddView(text, 0, 0, 80dip, 80dip)
		CLV.Add(Panel, Panel)
	Next
	
End Sub

Sub Panel_Touch (Action As Int, X As Float, Y As Float)
	Select Action
		Case 0 'down
			TouchedPanel = Sender
			PressTimer = DateTime.Now
		Case 1 'up
			PressTimeDiff = 0
		Case 2 'moving
			PressTimeDiff = DateTime.Now - PressTimer
			If PressTimeDiff > 500  Then 'If piece is longclicked for at least 500millisecond
				Private xPiecePositionOnCLV, yPiecePositionOnCLV As Float
				TouchedPanelCLVIndex = CLV.GetItemFromView(TouchedPanel)

				xPiecePositionOnCLV = (TouchedPanel.Width * TouchedPanelCLVIndex) - (TouchedPanel.Width * PanelCLVindexFromoffset)
				yPiecePositionOnCLV = Root.Height - TouchedPanel.Height * 2
				
				CheckTouchedPanelInCLV(TouchedPanelCLVIndex, xPiecePositionOnCLV, yPiecePositionOnCLV)
			End If
	End Select
End Sub

Sub CheckTouchedPanelInCLV(Index As Int, x As Float, y As Float) As B4XView
	CLV.RemoveAt(Index)
	TouchedPanel.RemoveViewFromParent
	Root.AddView(TouchedPanel, x, y, 80dip, 80dip)
	TouchedPanel.Color = Colors.Blue

	Return TouchedPanel
End Sub

Private Sub CLV_ScrollChanged (Offset As Int)
	PanelCLVindexFromoffset = CLV.FindIndexFromOffset(Offset)
End Sub
